{Five position switch and parallax LCD}


CON
        _clkmode = xtal1 + pll16x    'Standard clock mode * crystal frequency = 80 MHz
        _xinfreq = 5_000_000


  LCD_Pin = 15                   ' I/O Pin For LCD
  LCD_Baud = 19_200              ' LCD Baud Rate
  LCD_Lines = 2                  ' Parallax 2X16 Serial LCD (#27976)
  CR = 13
  'MoveMotor(pin) = 0
  
VAR
  long position
  long stack[35]                
OBJ
  LCD  : "debug_lcd"
  REC : "Simple_Serial"
  SSS : "single_Servo_Spin"
PUB start                
position := 138
 'Start a new cog and run the MoveMotor method on it that outputs pulses on Pin 7
cognew(MoveMotor(0),@Stack)

dira[16..20]~ ' Set pins 16-20 to input 

LCD.init(LCD_Pin, LCD_Baud, LCD_Lines)                ' Initialize LCD Object
  LCD.cursor(0)                                         ' Turn Off Cursor
  LCD.backlight(true)                                   ' Turn On Backlight   
  LCD.cls
  LCD.gotoxy(0,0)                                               ' Clear Display
  LCD.str(string("5 pos. switch", CR))                  'Print start up string
  waitcnt(clkfreq + cnt)
'  LCD.cls
 ' waitcnt(clkfreq +cnt)
  repeat
    if ina[16] == 0                         'check Left position of switch
      LCD.gotoxy(1, 1)
      LCD.str(string("Left"))
      position:=50
  
          waitcnt(clkfreq/4 +cnt)
    else
      LCD.gotoxy(1,1)
      LCD.str(string("      "))
    
    if ina[17] == 0
      LCD.gotoxy(1, 1)
      LCD.str(string("Down"))               'check down position of switch
      waitcnt(clkfreq/4 +cnt)
    else
      LCD.gotoxy(1,1)
      LCD.str(string("      "))
      
    if ina[18] == 0
      LCD.gotoxy(1,1)
      LCD.str(string("Right"))
      Position:=225
        
      waitcnt(clkfreq/4+cnt )     
    else
      LCD.gotoxy(1,1)
      LCD.str(string("     "))
      
    if ina[19] == 0
      LCD.gotoxy(7,1)
      LCD.str(string(" + Center "))
      Position:= 138'check Center position of switch
                                       'Set "Pin" Low
      waitcnt(clkfreq/100+cnt)
      
    else
      LCD.gotoxy(7,1)
      LCD.str(string("             "))
      
    if ina[20] == 0
      LCD.gotoxy(1,1)
      LCD.str(string("Up"))                     'check UP position of switch
      waitcnt(clkfreq/4 +cnt)
    else
      LCD.gotoxy(1,1)
      LCD.str(string("       "))          

    waitcnt(clkfreq +cnt)


PUB MoveMotor(Pin)                              'This method outputs a continuous stream of servo signal pulses on "Pin"
  dira[Pin]~~                                   'Set the direction of "Pin" to be an output
  repeat                                        'Send out a continous train of pulses
    outa[Pin]~~                                 'Set "Pin" High
    waitcnt((clkfreq/100_000)*position+cnt)     'Wait for the specifed position (units = 10 microseconds)
    outa[Pin]~                                  'Set "Pin" Low
    waitcnt(clkfreq/100+cnt)                    'Wait 10ms between pulses